AC_DEFUN([AC_ARG_ENABLE_DEBUG],
	[
		AC_ARG_ENABLE([debug], [AS_HELP_STRING([--enable-debug], [compile for debugging])],
			[enable_debug=yes],
			[enable_debug=no]
		)
		
		if test "${enable_debug}" = "yes" ; then
			CFLAGS="${CFLAGS} -g"
			CXXFLAGS="${CXXFLAGS} -g"
			FFLAGS="${FFLAGS} -g"
			FCFLAGS="${FCFLAGS} -g"
			AC_DEFINE([ENABLE_DEBUG], [1], [Defined to 1 if configured for debugging.])
		fi
		
		AM_CONDITIONAL([ENABLE_DEBUG], [test "${enable_debug}" = "yes"])
	]
)

AC_DEFUN([AC_ARG_ENABLE_INSTRUMENT],
	[
		AC_ARG_ENABLE([instrument], [AS_HELP_STRING([--enable-instrument], [compile with instrumentation])],
			[enable_instrument=yes],
			[enable_instrument=no]
		)
		
		if test "${enable_instrument}" = "yes" ; then
			AC_DEFINE([ENABLE_INSTRUMENT], [1], [Defined to 1 if configured for instrumented compilation.])
		fi
		
		AM_CONDITIONAL([ENABLE_INSTRUMENT], [test "${enable_instrument}" = "yes"])
	]
)

